diff --git a/fftools/cmdutils.c b/fftools/cmdutils.c
index d5cadec695..9cceb68412 100644
--- a/fftools/cmdutils.c
+++ b/fftools/cmdutils.c
@@ -34,6 +34,7 @@
 #include "libavformat/avformat.h"
 #include "libavformat/version.h"
 #include "libavfilter/avfilter.h"
+#include "libavfilter/version.h"
 #include "libavdevice/avdevice.h"
 #include "libavdevice/version.h"
 #include "libswscale/swscale.h"
diff --git a/fftools/ffprobe.c b/fftools/ffprobe.c
index f36397a6ff..48c39d2540 100644
--- a/fftools/ffprobe.c
+++ b/fftools/ffprobe.c
@@ -60,6 +60,7 @@
 #include "libswresample/version.h"
 #include "libpostproc/postprocess.h"
 #include "libpostproc/version.h"
+#include "libavfilter/version.h"
 #include "cmdutils.h"
 
 #include "libavutil/thread.h"
diff --git a/libavfilter/Makefile b/libavfilter/Makefile
index 56d33e6480..d5fc27a575 100644
--- a/libavfilter/Makefile
+++ b/libavfilter/Makefile
@@ -5,6 +5,7 @@ HEADERS = avfilter.h                                                    \
           buffersink.h                                                  \
           buffersrc.h                                                   \
           version.h                                                     \
+          version_major.h                                               \
 
 OBJS = allfilters.o                                                     \
        audio.o                                                          \
diff --git a/libavfilter/avfilter.c b/libavfilter/avfilter.c
index 1f37a70179..859c5b837b 100644
--- a/libavfilter/avfilter.c
+++ b/libavfilter/avfilter.c
@@ -43,6 +43,7 @@
 #include "formats.h"
 #include "framepool.h"
 #include "internal.h"
+#include "version.h"
 
 #include "libavutil/ffversion.h"
 const char av_filter_ffversion[] = "FFmpeg version " FFMPEG_VERSION;
diff --git a/libavfilter/avfilter.h b/libavfilter/avfilter.h
index b105dc3159..37effcf5cd 100644
--- a/libavfilter/avfilter.h
+++ b/libavfilter/avfilter.h
@@ -47,7 +47,7 @@
 #include "libavutil/pixfmt.h"
 #include "libavutil/rational.h"
 
-#include "libavfilter/version.h"
+#include "libavfilter/version_major.h"
 
 /**
  * Return the LIBAVFILTER_VERSION_INT constant.
diff --git a/libavfilter/version.h b/libavfilter/version.h
index 9a890c014f..40fa8d9c47 100644
--- a/libavfilter/version.h
+++ b/libavfilter/version.h
@@ -29,7 +29,8 @@
 
 #include "libavutil/version.h"
 
-#define LIBAVFILTER_VERSION_MAJOR   8
+#include "version_major.h"
+
 #define LIBAVFILTER_VERSION_MINOR  27
 #define LIBAVFILTER_VERSION_MICRO 100
 
@@ -44,14 +45,4 @@
 
 #define LIBAVFILTER_IDENT       "Lavfi" AV_STRINGIFY(LIBAVFILTER_VERSION)
 
-/**
- * FF_API_* defines may be placed below to indicate public API that will be
- * dropped at a future version bump. The defines themselves are not part of
- * the public API and may change, break or disappear at any time.
- */
-
-#define FF_API_SWS_PARAM_OPTION             (LIBAVFILTER_VERSION_MAJOR < 9)
-#define FF_API_BUFFERSINK_ALLOC             (LIBAVFILTER_VERSION_MAJOR < 9)
-#define FF_API_PAD_COUNT                    (LIBAVFILTER_VERSION_MAJOR < 9)
-
 #endif /* AVFILTER_VERSION_H */
diff --git a/libavfilter/version_major.h b/libavfilter/version_major.h
new file mode 100644
index 0000000000..de0cf6e979
--- /dev/null
+++ b/libavfilter/version_major.h
@@ -0,0 +1,42 @@
+/*
+ * Version macros.
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef AVFILTER_VERSION_MAJOR_H
+#define AVFILTER_VERSION_MAJOR_H
+
+/**
+ * @file
+ * @ingroup lavfi
+ * Libavfilter version macros
+ */
+
+#define LIBAVFILTER_VERSION_MAJOR   8
+
+/**
+ * FF_API_* defines may be placed below to indicate public API that will be
+ * dropped at a future version bump. The defines themselves are not part of
+ * the public API and may change, break or disappear at any time.
+ */
+
+#define FF_API_SWS_PARAM_OPTION             (LIBAVFILTER_VERSION_MAJOR < 9)
+#define FF_API_BUFFERSINK_ALLOC             (LIBAVFILTER_VERSION_MAJOR < 9)
+#define FF_API_PAD_COUNT                    (LIBAVFILTER_VERSION_MAJOR < 9)
+
+#endif /* AVFILTER_VERSION_MAJOR_H */